<?php

date_default_timezone_set('Asia/Tehran');
set_time_limit(0);
error_reporting(0);

require ('jdf.php');

ini_set('display_startup_errors', 0);
ini_set('display_errors', 0);
error_reporting(-1);

$Database = [
    'dbname' => "vilniusd_db",
    'username' => "vilniusd_db",
    'password' => 'ksJ#(HyTvMBl'
];

// ------------------ Configurations ------------------ //
$connection = mysqli_connect('localhost', $Database['username'], $Database['password'], $Database['dbname']);

// ------------------ Functions ------------------ //

function getJson($site ,$user, $pass){
    $loginUrl = $site . '/login';
    
    $postFields = array(
        "username" => $user,
        "password" => $pass
        );
        
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $loginUrl);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 15);
    curl_setopt($ch, CURLOPT_TIMEOUT, 15); 
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($postFields));
    curl_setopt($ch, CURLOPT_COOKIEJAR, "CHECKTEMPCOOKIE.txt");
    $loginResponse = json_decode(curl_exec($ch));
    if($loginResponse){
        if($loginResponse->success){
            $listUrl = $site . "/panel/inbound/list";
            
            curl_setopt($ch, CURLOPT_URL, $listUrl);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 15);
            curl_setopt($ch, CURLOPT_TIMEOUT, 15);
            curl_setopt($ch, CURLOPT_COOKIEJAR, "CHECKTEMPCOOKIE.txt");
            $response = curl_exec($ch);
    
            return json_decode($response);
            curl_close($ch);
        }else{
        }
    }else{
        return $loginResponse;
    }
}
function sumerize($bytes){
    if ($bytes >= 1073741824)
    {
        $bytes = number_format($bytes / 1073741824, 2);
        $bytes = ((int) $bytes == $bytes? (int) $bytes: $bytes). ' GB';
    }
    elseif ($bytes >= 1048576)
    {
        $bytes = number_format($bytes / 1048576, 2);
        $bytes = ((int) $bytes == $bytes? (int) $bytes: $bytes). ' MB';
    }
    elseif ($bytes >= 1024)
    {
        $bytes = number_format($bytes / 1024, 2);
        $bytes = ((int) $bytes == $bytes? (int) $bytes: $bytes). ' KB';
    }
    elseif ($bytes > 1)
    {
        $bytes = $bytes;
        $bytes = ((int) $bytes == $bytes? (int) $bytes: $bytes) . ' Byte';
    }
    elseif ($bytes == 1)
    {
        $bytes = $bytes;
        $bytes = ((int) $bytes == $bytes? (int) $bytes: $bytes). ' Byte';
    }
    else
    {
        $bytes = '0 Byte';
    }

    return $bytes;
}
function timeDiff($time2,$time1 = ''){
    if($time1 == ''){
        $time1 = time();
    }
    $diff = $time2 - $time1;
    if($diff <= 0){
        return "اتمام";
    }

    if($diff <= 60){
        return $diff.' ثانیه';
    }
    elseif($diff <= 3600){
        return round($diff / 60,0,1).' دقیقه';
    }
    elseif($diff >= 3660 && $diff <= 86400){
        return round($diff / 3600,0,1).' ساعت';
    }
    elseif($diff >= 86400){
        return round($diff / 86400,0,1).' روز';
    }
}

function getUserInfo($uuid){
    global $connection;
    $serversList = $connection->query("SELECT * FROM `servers`");
    $found = false;
    while($row = $serversList->fetch_assoc()){
        $serverId = $row['id'];
        $serverIp = $row['server_ip'];
        $serverName = $row['user_name'];
        $serverPass = $row['password'];
        $response = getJson($serverIp, $serverName, $serverPass);
        if($response){
            if($response->success){
                
                $list = json_encode($response->obj);
                
                if(strpos($list, $uuid) !== false){
                    $found = true;
                    $list = $response->obj;
                    if(!isset($list[0]->clientStats)){
                        foreach($list as $keys=>$packageInfo){
                        	if(strpos($packageInfo->settings, $uuid)!=false){
                        	    $remark = $packageInfo->remark;
                        	    $limitIp = $packageInfo->limitIp;
                                $upload = sumerize($packageInfo->up);
                                $download = sumerize($packageInfo->down);
                                $state = $packageInfo->enable == true?"فعال 🟢":"غیر فعال 🔴";
                                $totalUsed = sumerize($packageInfo->up + $packageInfo->down);
                                $total = $packageInfo->total!=0?sumerize($packageInfo->total):"نامحدود";
                                $expiryTime = $packageInfo->expiryTime != 0?jdate("Y/n/j H:i:s",substr($packageInfo->expiryTime,0,-3),null,null,"en"):"نامحدود";
                                $leftMb = $packageInfo->total!=0?sumerize($packageInfo->total - $packageInfo->up - $packageInfo->down):"نامحدود";
                                $expiryDay = $packageInfo->expiryTime != 0?
                                    floor(
                                        (substr($packageInfo->expiryTime,0,-3)-time())/(60 * 60 * 24))
                                        :
                                        "نامحدود";
                                if(is_numeric($expiryDay)){
                                    if($expiryDay<0) $expiryDay = 0;
                                    $expiryDay .= " روز";
                                }
                                break;
                        	}
                        }
                    }
                    else{
                        $keys = -1;
                        $settings = array_column($list,'settings');
                        foreach($settings as $key => $value){
                        	if(strpos($value, $uuid)!= false){
                        		$keys = $key;
                        		break;
                        	}
                        }
                        $clientsSettings = json_decode($list[$keys]->settings,true)['clients'];
                        if(!is_array($clientsSettings)){
                            break;
                        }
                        $settingsId = array_column($clientsSettings,'id');
                        $settingKey = array_search($uuid,$settingsId);
                        
                        if(!isset($clientsSettings[$settingKey]['email'])){
                            $packageInfo = $list[$keys];
                    	    $remark = $packageInfo->remark;
                    	    $limitIp = $packageInfo->limitIp;
                            $upload = sumerize($packageInfo->up);
                            $download = sumerize($packageInfo->down);
                            $state = $packageInfo->enable == true?"فعال 🟢":"غیر فعال 🔴";
                            $totalUsed = sumerize($packageInfo->up + $packageInfo->down);
                            $total = $packageInfo->total!=0?sumerize($packageInfo->total):"نامحدود";
                            $expiryTime = $packageInfo->expiryTime != 0?jdate("Y/n/j H:i:s",substr($packageInfo->expiryTime,0,-3),null,null,"en"):"نامحدود";
                            $leftMb = $packageInfo->total!=0?sumerize($packageInfo->total - $packageInfo->up - $packageInfo->down):"نامحدود";
                            if(is_numeric($leftMb)){
                                if($leftMb<0){
                                    $leftMb = 0;
                                }else{
                                    $leftMb = sumerize($packageInfo->total - $packageInfo->up - $packageInfo->down);
                                }
                            }
    
                            
                            $expiryDay = $packageInfo->expiryTime != 0?
                                floor(
                                    (substr($packageInfo->expiryTime,0,-3)-time())/(60 * 60 * 24)
                                    ):
                                    "نامحدود";    
                            if(is_numeric($expiryDay)){
                                if($expiryDay<0) $expiryDay = 0;
                                $expiryDay .= " روز";
                            }
                        }else{
                            $email = $clientsSettings[$settingKey]['email'];
                            $clientState = $list[$keys]->clientStats;
                            $emails = array_column($clientState,'email');
                            $emailKey = array_search($email,$emails);                    
                 
                            if($clientState[$emailKey]->total != 0 || $clientState[$emailKey]->up != 0  ||  $clientState[$emailKey]->down != 0 || $clientState[$emailKey]->expiryTime != 0){
                                $upload = sumerize($clientState[$emailKey]->up);
                                $download = sumerize($clientState[$emailKey]->down);
                                $leftMb = $clientState[$emailKey]->total!=0?($clientState[$emailKey]->total - $clientState[$emailKey]->up - $clientState[$emailKey]->down):"نامحدود";
                                if(is_numeric($leftMb)){
                                    if($leftMb<0){
                                        $leftMb = 0;
                                    }else{
                                        $leftMb = sumerize($clientState[$emailKey]->total - $clientState[$emailKey]->up - $clientState[$emailKey]->down);
                                    }
                                }
                                $totalUsed = sumerize($clientState[$emailKey]->up + $clientState[$emailKey]->down);
                                $total = $clientState[$emailKey]->total!=0?sumerize($clientState[$emailKey]->total):"نامحدود";
                                $expiryTime = $clientState[$emailKey]->expiryTime != 0?jdate("Y/n/j H:i:s",substr($clientState[$emailKey]->expiryTime,0,-3),null,null,"en"):"نامحدود";
                                $expiryDay = $clientState[$emailKey]->expiryTime != 0?
                                    floor(
                                        ((substr($clientState[$emailKey]->expiryTime,0,-3)-time())/(60 * 60 * 24))
                                        ):
                                        "نامحدود";
                                if(is_numeric($expiryDay)){
                                    if($expiryDay<0) $expiryDay = 0;
                                    $expiryDay .= " روز";
                                }
                                $state = $clientState[$emailKey]->enable == true?"فعال 🟢":"غیر فعال 🔴";
                                $remark = $email;
                            }
                            elseif($list[$keys]->total != 0 || $list[$keys]->up != 0  ||  $list[$keys]->down != 0 || $list[$keys]->expiryTime != 0){
                                $upload = sumerize($list[$keys]->up);
                                $download = sumerize($list[$keys]->down);
                                $leftMb = $list[$keys]->total!=0?($list[$keys]->total - $list[$keys]->up - $list[$keys]->down):"نامحدود";
                                if(is_numeric($leftMb)){
                                    if($leftMb<0){
                                        $leftMb = 0;
                                    }else{
                                        $leftMb = sumerize($list[$keys]->total - $list[$keys]->up - $list[$keys]->down);
                                    }
                                }
                                $totalUsed = sumerize($list[$keys]->up + $list[$keys]->down);
                                $total = $list[$keys]->total!=0?sumerize($list[$keys]->total):"نامحدود";
                                $expiryTime = $list[$keys]->expiryTime != 0?jdate("Y/n/j H:i:s",substr($list[$keys]->expiryTime,0,-3),null,null,"en"):"نامحدود";
                                $expiryDay = $list[$keys]->expiryTime != 0?
                                    floor(
                                        ((substr($list[$keys]->expiryTime,0,-3)-time())/(60 * 60 * 24))
                                        ):
                                        "نامحدود";
                                if(is_numeric($expiryDay)){
                                    if($expiryDay<0) $expiryDay = 0;
                                    $expiryDay .= " روز";
                                }
                                $state = $list[$keys]->enable == true?"فعال 🟢":"غیر فعال 🔴";
                                $remark = $list[$keys]->remark;
                                $limitIp = $list[$keys]->limitIp;
                            }
                        }
                    }
    
                    
                    $data = array();
                    $data['remark'] = $remark??" ";
                    $data['state'] = $state??" ";
                    $data['up'] = $upload??" ";
                    $data['down'] = $download??" ";
                    $data['total'] = $total??' ';
                    $data['leftGb'] = $leftMb??" ";
                    $data['endDate'] = $expiryTime??" ";
                    $data['leftDay'] = $expiryDay??" ";
                    $data['limitIp'] = $limitIp??" ";
                    return $data;
                    break;
                }
            }
        }
    }
    if(!$found){
  return "
  <center><img src='../images/pishro.gif' style='width: 200px;height: 200px;'/><center><br>
اکانتی با این کانفیگ یافت نشد...!!! تو نمیدونی چه بلایی سرما اومد... ";
}
}

?>
